#include"verasco.h"

void test1() {
  int a = verasco_any_int();
  verasco_assume(-1000 < a && a < 1000);
  int c = verasco_any_int();
  verasco_assume(-1000 < c && c < 1000);
  int b = a + c;
  verasco_assert(b-c > -1000);
  verasco_assert(b-c < 1000);
  verasco_assert(b-a > -1000);
  verasco_assert(b-a < 1000);
}

void test2() {
  int a = verasco_any_int();
  verasco_assume(-1000 < a && a < 1000);
  int b = a + 2;
  verasco_assert(b-a <= 2);
  verasco_assert(b-a >= 2);
  /* TODO : handle boolean expressions in octagons*/
  /* verasco_assert(b-a <= 2 && b-a >= 2); */
  /* TODO : handle inequalities in Octagons */
  /* verasco_assert(b-a == 2); */
  /* TODO */
  /* int c = b-a; */
  /* verasco_assert(b-a==2); */
}

void test3() {
  int a = verasco_any_int();
  verasco_assume(-1000 < a && a < 1000);
  int b = a + 2;
  b = b + 10;
  verasco_assert(b-a <= 12);
  verasco_assert(b-a >= 12);
}

void test4() {
  double a = verasco_any_double();
  verasco_assume(-1000 < a && a < 1000);
  double c = verasco_any_double();
  verasco_assume(-1000 < c && c < 1000);
  double b = a + c;
  verasco_assert(b-c > -1000.001);
  verasco_assert(b-c < 1000.001);
  verasco_assert(b-a > -1000.001);
  verasco_assert(b-a < 1000.001);
}

void test5() {
  double a = verasco_any_double();
  verasco_assume(-1000 < a && a < 1000);
  double b = a + 2;
  verasco_assert(b-a <= 2.001);
  verasco_assert(b-a >= 1.999);
}

void test6() {
  double a = verasco_any_int();
  verasco_assume(-1000 < a && a < 1000);
  double b = a + 2;
  b = b + 10;
  verasco_assert(b-a <= 12.001);
  verasco_assert(b-a >= 11.999);
}

void test7() {
  int a = verasco_any_int();
  verasco_assume(-1000 < a && a < 1000);
  int c = verasco_any_int();
  verasco_assume(-1000 < c && c < 1000);
  int b = -a - c;
  verasco_assert(b+c > -1000);
  verasco_assert(b+c < 1000);
  verasco_assert(b+a > -1000);
  verasco_assert(b+a < 1000);
}

void test8() {
  double a = verasco_any_int();
  verasco_assume(-1000 < a && a < 1000);
  double b = a + 2;
  b = -b + 10;
  verasco_assert(b+a <= 9);
  verasco_assert(b+a >= 7);
}

int main() {
  switch (verasco_any_int()) {
    case 1: test1(); break;
    case 2: test2(); break;
    case 3: test3(); break;
    case 4: test4(); break;
    case 5: test5(); break;
    case 6: test6(); break;
    case 7: test7(); break;
    case 8: test8(); break;
  }
  return 0;
}
