#include"verasco.h"

void test1() {
  int a = verasco_any_int();
  int b = verasco_any_int();
  verasco_assume(-1000 < a && a < 1000);
  verasco_assume(-1000 < b && b < 1000);
  verasco_assume(a >= b);
  verasco_assert(a > b-1);
  verasco_assert(a-b >= 0);
}

void test2() {
  double a = verasco_any_double();
  double b = verasco_any_double();
  verasco_assume(-1000 < a && a < 1000);
  verasco_assume(-1000 < b && b < 1000);
  verasco_assume(a >= b);
  verasco_assert(a >= b);
  verasco_assert(a - b >= -1e-10);
}

void test3() {
  int a = verasco_any_int();
  double b = verasco_any_double();
  verasco_assume(-1000 < a && a < 1000);
  verasco_assume(-1000 < b && b < 1000);
  verasco_assume(a >= b);
  verasco_assert(a >= b);
  verasco_assert(a-b >= -1e-10);
}

void test4() {
  int a = verasco_any_int();
  double b = verasco_any_double();
  verasco_assume(-1000000 < a && a < 1000000);
  verasco_assume(-1000000 < b && b < 1000000);
  if(a-a > 1E-100) verasco_assert(0);
  if(a-a > 0) verasco_assert(0);
  if(b-b > 1E-100) verasco_assert(0);
}

int main() {
  switch (verasco_any_int()) {
    case 1: test1(); break;
    case 2: test2(); break;
    case 3: test3(); break;
    case 4: test4(); break;
  }

  return 0;
}
